extends ../_docs-template

block vars
  - var title = 'Timeline | Framework7 Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu
  .docs-content
    .motion-docs-page-title
      h1 Timeline
      script(src="/js/motion/timeline.js")
      f7-motion-timeline(motion)

    p Framework7 comes with Timeline component that allows to display both Vertical & Horizontal timeline layouts.
    h2 Vertical Timeline
    p Common Vertical Timeline layout could be treated as the following:
    :code(lang="html")
          <div class="timeline">
            <div class="timeline-item">
              <div class="timeline-item-date">21 <small>DEC</small></div>
              <div class="timeline-item-divider"></div>
              <div class="timeline-item-content">
                <div class="timeline-item-inner">
                  <div class="timeline-item-time">12:30</div>
                  <div class="timeline-item-title">Title</div>
                  <div class="timeline-item-subtitle">Subtitle</div>
                  <div class="timeline-item-text">Text</div>
                </div>
              </div>
            </div>
            <div class="timeline-item">
              ... another timeline item ...
            </div>
          </div>
    p Where
    ul
      li `timeline` - main timeline wrapping element. Required
        ul
          li `timeline-item` - single timeline item. Required
            ul
              li `timeline-item-date` - timeline item date. Required
              li `timeline-item-divider` - timeline item decorative divider. Required for vertical timeline
              li `timeline-item-content` - timeline item content wrapping. You can put any content here: text, cards, list block, custom HTML or special timeline elements. Required
                ul
                  li `timeline-item-inner` - item content additional decorative wrapping. Optional
                  li `timeline-item-time` - item time. Optional
                  li `timeline-item-title` - item title. Optional
                  li `timeline-item-subtitle` - item subtitle. Optional
                  li `timeline-item-text` - item text. Optional
    h3 Vertical Timeline Example
    +examplePreview('core', 'timeline-vertical.html', 'timeline-vertical')


    h3 Vertical Timeline Side By Side
    p There is another "side-by-side" mode available for Vertical Timeline where each next item will be on different side. To enable "side-by-side" mode you need to add `timeline-sides` class to main `timeline` element.
    p It is also possible to enable this mode based on responsive breakpoint. For example, for tablet devices (width >= 786px) we need to add `medium-sides` class to main timeline element. For full set of such responsive classes check #[a(href="grid.html#column-sizes") Grid docs]. They are `xsmall-sides`, `small-sides`, `medium-sides`, `large-sides`, `xlarge-sides`.
    p To force timeline element to required side we may use additional `timeline-item-left` and `timeline-item-right` classes on single timeline item element `timeline-item`
    :code(lang="html")
          <!-- Each next item will on different side -->
          <div class="block-title">Side By Side</div>
          <div class="timeline timeline-sides">
            <div class="timeline-item">
              <div class="timeline-item-date">21 <small>DEC</small></div>
              <div class="timeline-item-divider"></div>
              <div class="timeline-item-content">
                <div class="timeline-item-inner">Some text goes here</div>
              </div>
            </div>
            <div class="timeline-item">
              <div class="timeline-item-date">22 <small>DEC</small></div>
              <div class="timeline-item-divider"></div>
              <div class="timeline-item-content">
                <div class="timeline-item-inner">Another text goes here</div>
              </div>
            </div>
            <div class="timeline-item">
              <div class="timeline-item-date">23 <small>DEC</small></div>
              <div class="timeline-item-divider"></div>
              <div class="timeline-item-content">
                <div class="timeline-item-inner">Just plain text</div>
              </div>
            </div>
            <div class="timeline-item">
              <div class="timeline-item-date">24 <small>DEC</small></div>
              <div class="timeline-item-divider"></div>
              <div class="timeline-item-content">
                <div class="timeline-item-inner">One more text here</div>
              </div>
            </div>
          </div>
          <!-- Each next item will on different side only on large tablet screens (iPad) -->
          <div class="block-title">Only Tablet Side By Side</div>
          <div class="timeline medium-sides">
            <div class="timeline-item">
              <div class="timeline-item-date">21 <small>DEC</small></div>
              ...
            </div>
            <div class="timeline-item">
              <div class="timeline-item-date">22 <small>DEC</small></div>
              ...
            </div>
            <div class="timeline-item">
              <div class="timeline-item-date">23 <small>DEC</small></div>
              ...
            </div>
            <div class="timeline-item">
              <div class="timeline-item-date">24 <small>DEC</small></div>
              ...
            </div>
          </div>
          <!-- Forced sides -->
          <div class="block-title">Forced Sides</div>
          <div class="timeline timeline-sides">
            <!-- Force to right side by additional "timeline-item-right" class -->
            <div class="timeline-item timeline-item-right">
              <div class="timeline-item-date">21 <small>DEC</small></div>
              ...
            </div>
            <!-- Force to right side by additional "timeline-item-right" class -->
            <div class="timeline-item timeline-item-right">
              <div class="timeline-item-date">22 <small>DEC</small></div>
              ...
            </div>
            <!-- Force to left side by additional "timeline-item-left" class -->
            <div class="timeline-item timeline-item-left">
              <div class="timeline-item-date">23 <small>DEC</small></div>
              ...
            </div>
            <!-- Force to left side by additional "timeline-item-left" class -->
            <div class="timeline-item timeline-item-left">
              <div class="timeline-item-date">24 <small>DEC</small></div>
              ...
            </div>
          </div>
    h2 Horizontal Timeline
    p Horizontal Timeline has the same layout as Vertical but with an additional `timeline-horizontal` class on main `timeline` element.
    p We can also control columns per view in timeline by using <a href="grid.html">Layout Grid</a> columns' classes like `timeline-cols-3` and `medium-timeline-cols-5` (to define column width for large tablet screens).
    +examplePreview('core', 'timeline-horizontal.html', 'timeline-horizontal')

    h2 Calendar Timeline
    p Calendar Timeline has almost the same layout as Horizontal but with additional Year and Month wrapping elements, so the structure should be the following:
    +examplePreview('core', 'timeline-horizontal-calendar.html', 'timeline-horizontal-calendar')


    +cssVars('timeline')
